<?php

class onMomentsContentMomentsBeforeItem extends cmsAction {

    public function run($data){

        list($ctype, $item, $fields) = $data;

        $content_model = cmsCore::getModel('content');

        $mc_field = '';
        foreach ($fields as $name => $value){
            if ($value['type'] == 'moments'){$mc_field = $name; break;}
        }
        $parent = $content_model->
            filterEqual('m.item_id', $item['id'])->
            filterGt('m.mc_parent_id', '0')->
            join('moments', 'm', 'm.mc_parent_id = i.id')->
            getItem('con_moments', function($item) use($mc_field){
                $item = $item + cmsModel::yamlToArray($item[$mc_field]);
                unset($item[$mc_field]);
                return $item;
            });

        $chaild = $content_model->
            filterEqual('m.mc_parent_id', $item['id'])->
            join('moments', 'm', 'm.item_id = i.id')->
            get('con_moments', function($item) use($mc_field){
                $item = $item + cmsModel::yamlToArray($item[$mc_field]);
                unset($item[$mc_field]);
                return $item;
            });

        if ($parent){
            $item['mc_parent'] = $parent;
        }

        if ($chaild){
            $item['mc_chaild'] = $chaild;
        }

        return array($ctype, $item, $fields);
    }
}