<?php

class actionMomentsGetItemsAjax extends cmsAction {

    public function run(){

        if (!$this->request->isAjax()){ cmsCore::error404(); }
        if (!cmsUser::isLogged()) { cmsCore::error404(); }

        $list = array('0'=>'');

        $category_id = $this->request->get('cat_id');
        $item_id = $this->request->get('item_id');

        if (!$category_id) { $this->cms_template->renderJSON($list); }

        $items = cmsCore::getModel('content')->
            filterCategoryId('moments', $category_id)->
            get('con_moments');

        if ($item_id){unset($items[$item_id]);}
        if ($items){
            $list = $list + array_collection_to_list($items, 'id', 'title');
        }

        $this->cms_template->renderJSON($list);
    }
}